# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](http://keepachangelog.com/)
and this project adheres to [Semantic Versioning](http://semver.org/).

## 0.1.4 - 2023-06-15

Getting Stheno ready for our Alpha release, and I think we're in a fairly usable place now. I'll be adding lots more in the next couple weeks but I'd consider this the first "yeah you could probably use this" release.

### Added

- Add keyboard shortcuts for markdown styling
- Create slash commands for more complex "components" (code blocks, links, images)
- Add light and dark mode syntaxes based on GitHub's current light and dark mode colors

### Fixed

- Update build system from parcel to `@codemirror/buildhelper`
- Better encapsulate the functionality

## 0.1.3 - 2023-06-10

### Added
- Created both Light and Dark themes for Yetto
- Created a fully featured example that includes a toolbar to demonstrate how to interact with Stheno's internal commands
- Updated the config to work more ergonomically with Stimulus

## 0.1.1 - 2022-12-17

### Fixed

- Typescript errors in Parcel were messing with our packages output. This has been resolved and you should be able to install and consume the package normally.
- The README was in the .github directory, which I prefer but doesn't allow NPM to read it as part of the package. I moved it to solve that issue.

## 0.1.0 - 2022-12-01

### Added

- An initial codemirror config for a Proof of Concept on how Codemirror meet's Yetto's needs.
- An example playground for testing the configuration
- A readme and some basic usage documentation
